<?php defined('SYSPATH') OR die('No direct access allowed.');

class Cron_File_Driver extends Cron_Driver
{

    public function __construct(array $config)
    {
	parent::__construct($config);

	$this->config=$config;                
    }



    public function find_all()
    {
	$this->_parse();
//echo '<pre>';print_r($this->_files);echo '</pre>';die();
	return $this->_files;
    }


    public function find_one()
    {
	if(count($this->_array_data)<1)
	{
	    $this->_parse();
	}

	return $this->_array_data;
    }


    public function save($model)
    {
	$this->add($model);

	if($model->filename!=$model->filename_old)
	{
	    if(!$this->delete_file($model));
	    {
		return false;
	    }
	}

	return true;
    }


    public function add($model)
    {
	$rule=$this->create_rule($model);

	$comment=$this->create_comment($model->comment);

	$string_command=$rule.' root '.$model->command;

	$file=fopen($this->config['path'].$model->filename,'w');
	fwrite($file,$comment."\r\n");
	fwrite($file,$string_command);
	fclose($file);
    }


    public function create_comment($comment)
    {
	$string = '';

	$data = explode("\n",$comment);

	foreach($data as $val)
	{
	    $string.='# '.$val.'\r\n';
	}

	return $string;
    }

    public function delete_file($model)
    {
	$command="cd ".$this->config['path']." && rm  ".$model->filename_old;

	 exec($command,$array,$code);
	 if($code!='0')
	 {
	    return false;
	 }

	 return true;
    }


    public function create_rule($model)
    {
	$string = '';
	
	$data=array(
	    'minutes' => $model->minutes,
	    'hours'   => $model->hours,
	    'days'    => $model->days,
	    'month'   => $model->month,
	    'week'    => $model->week,  
	);

	$data_k=array(
	    'minutes_k'=> $model->minutes_k,
	    'hours_k'  => $model->hours_k,
	    'days_k'   => $model->days_k,
	    'month_k'  => $model->month_k,
	    'week_k'   => $model->week_k
	);

	$data_krat=array(
	    'minutes_krat'=> $model->minutes_krat,
	    'hours_krat'  => $model->hours_krat,	    
	    'days_krat'   => $model->days_krat,
	    'month_krat'  => $model->month_krat,
	    'week_krat'   => $model->week_krat
	);

	foreach($data as $key=>$value)
	{
	    if($value!='*')
	    {
		$string.=$value.' ';
	    }
	    else
	    {
		if($data_k[$key.'_k']=='1')
		{
		    $string.=$value.'/'.$data_krat[$key.'_krat'].' ';
		}
		else
		{
		    $string.=$value.' ';
		}
	    }

	}

	return $string;
    }

    private function _parse()
    {
	$command='cd '.$this->config['path'].' && ls';
	exec($command,$array,$code);
	foreach($array as $filename)
	{
	   $file=file($this->config['path'].$filename);
	   foreach($file as $value)
	   {
		$value_='__'.$value;
		$test=strpos($value_,'*');

		$test2=strpos($value_,'_#');
	   
		if($test==true and $test2==false)
		{
		    $this->_array_command['command'][]=$value;

		    $string = $value;
		    $data = explode(' ',$string);
		   
		    foreach($data as $key=>$val)
		    {
			$t=strpos($val,'/');
			if($t==true)
			{
				$krat='1';
				$data2=explode('/',$val);
				//print_r($data2);
				$val=$data2[0];
				$krat_val=$data2[1];

				$var=$val.'/'.$krat_val;
			}
			else
			{
				$krat='0';
				$krat_val='';
				$var=$val;
			}

			switch($key)
			{
				case '0':
					$this->_array_data[$filename]['minute']['krat_val']=$krat_val;
					$this->_array_data[$filename]['minute']['krat']=$krat;
					$this->_array_data[$filename]['minute']['val']=$val;
					$this->_array_data[$filename]['minute']['all']=$var;
					$minute=$var;
				break;

				case '1':
					$this->_array_data[$filename]['hours']['krat_val']=$krat_val;
					$this->_array_data[$filename]['hours']['krat']=$krat;
					$this->_array_data[$filename]['hours']['val']=$val;
					$this->_array_data[$filename]['hours']['all']=$var;
					$hours=$var;
				break;

				case '2':
					$this->_array_data[$filename]['days']['krat_val']=$krat_val;
					$this->_array_data[$filename]['days']['krat']=$krat;
					$this->_array_data[$filename]['days']['val']=$val;
					$this->_array_data[$filename]['days']['all']=$var;
					$days=$var;
				break;

				case '3':
					$this->_array_data[$filename]['month']['krat_val']=$krat_val;
					$this->_array_data[$filename]['month']['krat']=$krat;
					$this->_array_data[$filename]['month']['val']=$val;
					$this->_array_data[$filename]['month']['all']=$var;
					$month=$var;
				break;

				case '4':
					$this->_array_data[$filename]['week']['krat_val']=$krat_val;
					$this->_array_data[$filename]['week']['krat']=$krat;
					$this->_array_data[$filename]['week']['val']=$val;
					$this->_array_data[$filename]['week']['all']=$var;
					$week=$var;
				break;

				case '5':
					$data = explode(' ',$string);
					$str='';
					for($i=5;$i<count($data);$i++)
					{
					    $str.=$data[$i].' ';
					}
					$this->_array_data[$filename]['command']=str_replace('root ','',$str);
				break;
			}
		    }
		}

		if($test2==true)
		{
		    $this->_array_data[$filename]['comment_'][]=$value;
		}
	    }
	}

	

	foreach($this->_array_data as $key => $value)
	{
	    $string='';
	    if(isset($this->_array_data[$key]['comment_']))
	    {
		foreach($this->_array_data[$key]['comment_'] as $k=>$val)
		{
		    $string.=str_replace('#','',$val).' ';
		}
	    }
	    $this->_array_data[$key]['comment']=str_replace('\n','',str_replace('\r\n','',$string));
	}

	$this->_files = $this->_array_data;
    }




    public function task_key()
    {
	$this->_parse();

	$array=array();
	foreach($this->_array_data as $key=>$value)
	{
	    $array[]=$key;
	}
	return $array;
    }

    private $_array_command = array();
    private $_array_data    = array();

    private $_files	    = array();
}
